suite: test service.yaml
templates:
  - service.yaml

tests:
  - it: should not create Service when service.enabled is false
    set:
      service.enabled: false
    asserts:
      - hasDocuments:
          count: 0

  - it: should create Service when service.enabled is true
    set:
      service.enabled: true
    asserts:
      - hasDocuments:
          count: 1
      - isKind:
          of: Service
      - matchRegex:
          path: metadata.name
          pattern: '.*'

  - it: should include custom labels
    set:
      service.enabled: true
      service.labels.customLabel: "customValue"
    asserts:
      - equal:
          path: metadata.labels.customLabel
          value: "customValue"

  - it: should include common annotations
    set:
      service.enabled: true
      common.annotations.common-annotation: "common-value"
    asserts:
      - equal:
          path: metadata.annotations.common-annotation
          value: "common-value"

  - it: should set Service type correctly
    set:
      service.enabled: true
      service.type: ClusterIP
    asserts:
      - equal:
          path: spec.type
          value: ClusterIP

  - it: should set Service port correctly
    set:
      service.enabled: true
      service.port: 8080
    asserts:
      - equal:
          path: spec.ports[0].port
          value: 8080

  - it: should include extra ports
    set:
      service.enabled: true
      service.extraPorts:
        - name: smtp
          port: 587
          targetPort: 25
    asserts:
      - equal:
          path: spec.ports[1].port
          value: 587
      - equal:
          path: spec.ports[1].targetPort
          value: 25